#include "RainLut.h"

RainLut::RainLut( int16 phase, bool last, int16 width )
	: mLutPtr( NULL )
{
	mLutPtr = new uint16[ kLutWidth * kLutWidth ];
	
	double t = (double)phase;
	
	uint16 *lutPtr = mLutPtr;
	
	for ( int32 y = 0; y < kLutWidth; y++ ){

		double dy = y - ( kLutWidth / 2.0 );

		for ( int32 x = 0; x < kLutWidth; x++ ){
			double dx = x - ( kLutWidth / 2.0 );
			double r = sqrt( dx * dx + dy * dy );
			double delta = r - kV * t;
		
			if ( delta > -5.0 && delta < 5.0 && !last ){
				*lutPtr++ = 2 * width + 2;	// Offset by 2 in x and y
			}else{
				*lutPtr++ = 0;					// No offset
			} 
		}
	}
	
	return;
}

RainLut::~RainLut()
{
	delete mLutPtr;
	
	return;
}

